var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.default=exports.rnvHelp=void 0;var _regenerator=_interopRequireDefault(require("@babel/runtime/regenerator"));var _chalk=_interopRequireDefault(require("chalk"));
var _inquirer=_interopRequireDefault(require("inquirer"));
var _logger=require("../systemTools/logger");
var _workspace=require("../projectTools/workspace");
var _projectGenerator=require("../projectTools/projectGenerator");
var _templateTools=require("../templateTools");
var _target=require("../platformTools/target");
var _pluginTools=require("../pluginTools");
var _platformTools=require("../platformTools");
var _buildHooks=require("../projectTools/buildHooks");
var _projectTools=require("../projectTools");
var _crypto=require("../systemTools/crypto");
var _cleaner=require("../systemTools/cleaner");
var _runner=require("../platformTools/runner");

var rnvHelp=function rnvHelp(){
var cmdsString='';
for(var key in COMMANDS){
cmdsString+=key+", ";
}

(0,_logger.logToSummary)("\n"+
_chalk.default.bold.white('COMMANDS:')+"\n\n"+

cmdsString+"\n\n"+

_chalk.default.bold.white('OPTIONS:')+"\n\n'-i, --info', 'Show full debug info'\n'-u, --update', 'Force update dependencies (iOS only)'\n'-p, --platform <value>', 'Select specific platform' // <ios|android|web|...>\n'-c, --appConfigID <value>', 'Select specific appConfigID' // <ios|android|web|...>\n'-t, --target <value>', 'Select specific simulator' // <.....>\n'-d, --device [value]', 'Select connected device'\n'-s, --scheme <value>', 'Select build scheme' // <Debug | Release>\n'-f, --filter <value>', 'Filter Value'\n'-l, --list', 'Return list of items related to command' // <alpha|beta|prod>\n'-r, --reset', 'Also perform reset'\n'-b, --blueprint', 'Blueprint for targets'\n'-h, --host <value>', 'Custom Host IP'\n'-x, --exeMethod <value>', 'Executable method in buildHooks'\n'-P, --port <value>', 'Custom Port'\n'-H, --help', 'Help'\n'-D, --debug', 'enable remote debugger'\n'--hosted', 'Run in a hosted environment (skip bundleAssets)'\n'--debugIp <value>', '(optional) overwrite the ip to which the remote debugger will connect'\n");




















};exports.rnvHelp=rnvHelp;


var COMMANDS={
start:{
fn:_runner.rnvStart},

run:{
desc:'Run your app on target device or emulator',
fn:_runner.rnvRun},

package:{
desc:'Package JS Code',
fn:_runner.rnvPackage},

deploy:{
desc:'Deploy whole app via preconfigured or custom integration',
fn:_runner.rnvDeploy},

build:{
desc:'Build your app',
fn:_runner.rnvBuild},

export:{
desc:'Export your app (ios only)',
fn:_runner.rnvExport},

log:{
desc:'Attach logger to device or emulator and print out logs',
fn:_runner.rnvLog},

new:{
fn:_projectGenerator.createNewProject,
desc:'Creates new project',
params:['mono','ci']},

help:{
desc:'Displays help',
fn:rnvHelp},

configure:{
desc:'Configures app config',
fn:_projectTools.rnvConfigure,
params:['appConfigID','mono','ci']},

switch:{
desc:'Switches to app confing without rebuilding',
fn:_projectTools.rnvSwitch,
params:['appConfigID','mono','ci']},

link:{
desc:'Local dependency linking of your project',
fn:_pluginTools.rnvLink},

platform:{
desc:'Manages native platform projects',
subCommands:{
eject:{
fn:_platformTools.rnvPlatformEject},

list:{
fn:_platformTools.rnvPlatformList},

connect:{
fn:_platformTools.rnvPlatformConnect},

configure:{
fn:_platformTools.rnvPlatformConfigure}}},



target:{
desc:'Manages simulators and emulators',
subCommands:{
launch:{
fn:_target.rnvTargetLaunch},

list:{
fn:_target.rnvTargetList}}},



plugin:{
desc:'Manages all plugins',
subCommands:{
add:{
fn:_pluginTools.rnvPluginAdd},

list:{
fn:_pluginTools.rnvPluginList},

update:{
fn:_pluginTools.rnvPluginUpdate}}},



hooks:{
desc:'Manages project based build hooks. This allows you to extend functionality of RNV CLI',
subCommands:{
run:{
fn:_buildHooks.rnvHooksRun},

list:{
fn:_buildHooks.rnvHooksList},

pipes:{
fn:_buildHooks.rnvHooksPipes}}},



status:{
desc:'Prints out summary of your project',
fn:_logger.rnvStatus},

clean:{
desc:'Automatically removes all node_modules and lock in your project and its dependencies',
fn:_cleaner.rnvClean},

template:{
desc:'Manages rnv and project templates',
subCommands:{
add:{
fn:_templateTools.rnvTemplateAdd},

list:{
fn:_templateTools.rnvTemplateList},

apply:{
fn:_templateTools.rnvTemplateApply}}},



crypto:{
desc:'Utility to manage encrytped files in your project, provisioning profiles, kestores and other sensitive information',
subCommands:{
encrypt:{
fn:_crypto.rnvCryptoEncrypt},

decrypt:{
fn:_crypto.rnvCryptoDecrypt},

installCerts:{
fn:_crypto.rnvCryptoInstallCerts},

updateProfile:{
fn:_crypto.rnvCryptoUpdateProfile},

updateProfiles:{
fn:_crypto.rnvCryptoUpdateProfiles},

installProfiles:{
fn:_crypto.rnvCryptoInstallProfiles}}},



workspace:{
desc:'Manages global workspaces for ReNative projects',
subCommands:{
add:{
fn:_workspace.rnvWorkspaceAdd},

connect:{
fn:_workspace.rnvWorkspaceConnect},

list:{
fn:_workspace.rnvWorkspaceList},

update:{
fn:_workspace.rnvWorkspaceUpdate}}}};










var run=function run(c){var _cmd$subCommands;var cmd,cmdFn,subCmd,subCmdFn;return _regenerator.default.async(function run$(_context){while(1){switch(_context.prev=_context.next){case 0:
(0,_logger.logTask)('cli');

cmd=COMMANDS[c.command];
cmdFn=cmd==null?void 0:cmd.fn;
subCmd=cmd==null?void 0:(_cmd$subCommands=cmd.subCommands)==null?void 0:_cmd$subCommands[c.subCommand];
subCmdFn=subCmd==null?void 0:subCmd.fn;if(!

cmd){_context.next=42;break;}if(!(
c.subCommand==='help')){_context.next=11;break;}_context.next=9;return _regenerator.default.awrap(
_execCommandHep(c,cmd));case 9:_context.next=40;break;case 11:if(!
cmdFn){_context.next=29;break;}if(!
subCmdFn){_context.next=21;break;}_context.next=15;return _regenerator.default.awrap(
(0,_buildHooks.executePipe)(c,c.command+":"+c.subCommand+":before"));case 15:_context.next=17;return _regenerator.default.awrap(
subCmdFn(c));case 17:_context.next=19;return _regenerator.default.awrap(
(0,_buildHooks.executePipe)(c,c.command+":"+c.subCommand+":after"));case 19:_context.next=27;break;case 21:_context.next=23;return _regenerator.default.awrap(

(0,_buildHooks.executePipe)(c,c.command+":before"));case 23:_context.next=25;return _regenerator.default.awrap(
cmdFn(c));case 25:_context.next=27;return _regenerator.default.awrap(
(0,_buildHooks.executePipe)(c,c.command+":after"));case 27:_context.next=40;break;case 29:if(!

subCmdFn){_context.next=38;break;}_context.next=32;return _regenerator.default.awrap(
(0,_buildHooks.executePipe)(c,c.command+":"+c.subCommand+":before"));case 32:_context.next=34;return _regenerator.default.awrap(
subCmdFn(c));case 34:_context.next=36;return _regenerator.default.awrap(
(0,_buildHooks.executePipe)(c,c.command+":"+c.subCommand+":before"));case 36:_context.next=40;break;case 38:_context.next=40;return _regenerator.default.awrap(

_handleUnknownSubCommand(c));case 40:_context.next=44;break;case 42:_context.next=44;return _regenerator.default.awrap(


_handleUnknownCommand(c));case 44:return _context.abrupt("return",

c);case 45:case"end":return _context.stop();}}});};






var _execCommandHep=function _execCommandHep(c,cmd){var opts,subCommands;return _regenerator.default.async(function _execCommandHep$(_context2){while(1){switch(_context2.prev=_context2.next){case 0:
opts='';
subCommands='';

if(cmd.subCommands){
subCommands='\nSub Commands: \n';
subCommands+=Object.keys(cmd.subCommands).join(', ');
subCommands+='\n';
}

if(cmd.params){
opts='Options:\n';
opts+=(cmd.params||[]).reduce(function(t,v){return t+"--"+v+"\n";},'');
}

(0,_logger.logToSummary)("\nCommand: "+
c.command+"\n\nDescription: "+

cmd.desc+".\n"+
subCommands+"\n"+
opts+"\nMore info at "+
_chalk.default.grey("https://renative.org/docs/rnv-"+c.command)+"\n");return _context2.abrupt("return",

Promise.resolve());case 6:case"end":return _context2.stop();}}});};


var _handleUnknownSubCommand=function _handleUnknownSubCommand(c){var _COMMANDS$c$command;var cmds,_ref,subCommand;return _regenerator.default.async(function _handleUnknownSubCommand$(_context3){while(1){switch(_context3.prev=_context3.next){case 0:
(0,_logger.logTask)('_handleUnknownSubCommand');
(0,_logger.logWarning)("cli: Command "+_chalk.default.white.bold(c.command)+" does not support method "+_chalk.default.white.bold(c.subCommand)+"!");

cmds=(_COMMANDS$c$command=COMMANDS[c.command])==null?void 0:_COMMANDS$c$command.subCommands;_context3.next=5;return _regenerator.default.awrap(

_inquirer.default.prompt({
type:'list',
name:'subCommand',
message:'Pick a subCommand',
choices:Object.keys(cmds)}));case 5:_ref=_context3.sent;subCommand=_ref.subCommand;


c.subCommand=subCommand;return _context3.abrupt("return",
run(c));case 9:case"end":return _context3.stop();}}});};


var _handleUnknownCommand=function _handleUnknownCommand(c){var _ref2,command;return _regenerator.default.async(function _handleUnknownCommand$(_context4){while(1){switch(_context4.prev=_context4.next){case 0:
(0,_logger.logTask)('_handleUnknownCommand');
(0,_logger.logWarning)("cli: Command "+_chalk.default.white.bold(c.command)+" not supported!");_context4.next=4;return _regenerator.default.awrap(
_inquirer.default.prompt({
type:'list',
name:'command',
message:'Pick a command',
choices:Object.keys(COMMANDS)}));case 4:_ref2=_context4.sent;command=_ref2.command;


c.command=command;return _context4.abrupt("return",
run(c));case 8:case"end":return _context4.stop();}}});};var _default=







run;exports.default=_default;